<template>
  <div>
    <div v-if="!options.hideField">
      <template v-if="options && options.beforeField">
        <div v-for="(comp, index) in options.beforeField" :key="Math.random() + index">
          <component :is="comp" :node="node" :path="path"></component>
        </div>
      </template>

      <component :is="componentSelection" :node="node" :path="path" :field="field" :defaults="defaults"></component>

      <template v-if="options && options.afterField">
        <div v-for="(comp, index) in options.afterField" :key="Math.random() + index">
          <component :is="comp" :node="node" :path="path"></component>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'

import { EDITABLE_SETTINGS_FIELD_CONFIG, EDITABLE_SETTINGS_FIELDS_MAPPING } from '@/components/Editable/config'

import { mapGetters, mapActions } from 'vuex'

export default {
  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    },
    // config: {
    //   type: Object,
    //   required: true
    // },
    field: {
      type: String,
      required: true
    },
    defaults: {
      required: false
    }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      getFieldConfig: 'Y3TI/getFieldConfig',
      getEditedField: 'Y3TI/getEditedField'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },
    // fieldData: {
    //   get () {
    //     // return _.get(this.$store.state.app.edited, this.editablePath)
    //     return this.getEditedField({ node: this.node, path: this.path })
    //   },
    //   set (value) {
    //     this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value } })
    //   }
    // }
    componentSelection () {
      // return this.getFieldsMapping(this.config, _.get(this.config, [ 'description', this.field ], {}), this.node, [...this.path, this.field])
      return this.getFieldsMapping(this.optionsProps)
    },

    data () {
      return this.getEditedField({ node: this.node, path: this.path })
    },

    optionsProps () {
      return {
        config: this.config,
        fieldConfig: _.get(this.config, [ 'description', this.field ], {}),
        node: this.node,
        path: [...this.path, this.field],
        key: this.field,
        data: this.data,
        fieldData: _.get(this.data, this.field)
      }
    },

    options () {
      // console.log('aaaa')
      // return this.getFieldOptions(this.config, _.get(this.config, [ 'description', this.field ], {}), this.node, [...this.path, this.field], this.fieldData)
      return this.getFieldOptions(this.optionsProps)
    }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...[this.config.path] ]
    // }
  },

  methods: {
    ...mapActions({
    }),

    getFieldsMapping: EDITABLE_SETTINGS_FIELDS_MAPPING,
    getFieldOptions: EDITABLE_SETTINGS_FIELD_CONFIG
  }
}
</script>

<style lang="scss" scoped>
</style>
